%{
//File:	  arithmetic.lex
//Author: Robert C. Broeckelmann Jr.
//Date:   8 Nov 2003
//Notes:
//		I stole this from someone's compiler class initially.
//
//		If you're reading this in the arithmetic.lex.yy.c file, do not edit this file,
//		edit the arithmetic.lex file and recompile.
//
//		Define all the token numbers. Note that the scanner created by
//		flex will automatically return 0 at end-of-file (not -1).
//		Two symbols (open and close parentheses) will just use their
//		ascii values for the token number, so no definition is
//		needed.

#include "arithmetic.tab.h"
//
//Needed for calls to C Standard Library...
//
//#include"stdafx.h"
#include<stdio.h>
#include<stdlib.h>

// Declare a global variable to keep track of the current input 
// line number:
int yyline = 1;

%}


%{
// DEFINITIONS OF REGULAR EXPRESSIONS
%}
separator         [ \n\r\t\v]
digits            [0-9]+
letters			  [a-h,j-z]|[A-Z]+
variable		  {letters}
exponent          [eE][+-]?{digits}
number1           {digits}{exponent}?
number2           {digits}"."{digits}{exponent}?            
number3           {digits}"."{exponent}?            
number4           "."{digits}{exponent}?
number            {number1}|{number2}|{number3}|{number4} 
%%

%{
// FLEX RULES.
// Notes:
//  1. yytext is a null-terminated string that contains the characters
//  of the pattern that was just matched. For example, yytext[0]
//  is the first character of the pattern that was matched.
//
//  2. The symbol | instead of an action means "or" and the pattern
//  is combined with the next pattern (with the same action when
//  they are matched). I use this "or" operation for the 
//  open and close parentheses since in both cases the token
//  number is just the ascii value of the character (which is
//  obtained from yytext[0]).
//
//  3. If you want the action to contain more than one line,
//  the first action line should be an open bracket, and put a
//  close bracket after the last action line.
%}
{number}            printf("number: %c\n", yytext[0]); return NUMBER;
{variable}			printf("variable: %c\n", yytext[0]); return VARIABLE;
"i"					printf("i\n"); return IMAGINARY;
"+"                 printf("+\n"); return PLUS; 
"-"                 printf("-\n"); return MINUS;
"*"                 printf("*\n"); return TIMES;
"/"                 printf("/\n"); return DIVIDE;
"**"                printf("**\n"); return EXP;
"("					printf("(\n"); return LEFT_BRACKET;
")"					printf(")\n"); return RIGHT_BRACKET;
"="					printf("=\n"); return EQUAL;
":="				printf(":=\n"); return ASSIGNMENT_EQUAL;
{separator}         {
                        if (yytext[0] == '\n')
                            yyline++;
                    }
.                   return yytext[0];

%%
/* USER SUBROUTINES SECTION */